/*
 * AD840x.c
 *
 *  Created on: 25.11.2010
 *      Author: Frank Link
 */

#include "AD840x.h"

#ifdef AD8400
uint8_t currentVolume;
#endif

void initAD840x(void)
{
	// Ports auf Ausgang
	AD840x_DDR |= AD840x_SET_OUT;
	// Alle notwendigen Ausgnge auf 0 setzen
	AD840x_PORT &= ~AD840x_SET_OUT;
	// CS, SHDN und RS auf 1
	AD840x_CS_ON;
#ifndef AD8400
	AD840x_SHDN_ON;
	AD840x_RS_ON;
	// Reset durchfhren
	AD840x_RS_STROBE;
#else
	setAD840xVolume( 1 );
#endif
	_delay_us( 2 );
}

void _set840xAdress( uint8_t adress )
{
    register unsigned char AdressBitCount = 2;

	do
	{
		if (adress & 0x80)
		{
			AD840x_SDI_ON;
		}
		else
		{
			AD840x_SDI_OFF;
		}
		AD840x_CLK_STROBE;

		adress <<= 1;
	} while ( --AdressBitCount );
}

void _set840xVolume( uint8_t volume )
{
    register unsigned char VolumeBitCount = 8;

#ifdef AD8400
    currentVolume = volume;
#endif

	do
	{
		if (volume & 0x80)
		{
			AD840x_SDI_ON;
		}
		else
		{
			AD840x_SDI_OFF;
		}
		AD840x_CLK_STROBE;

		volume <<= 1;
	} while ( --VolumeBitCount );
}

void set840xVolume( uint8_t adress, uint8_t volume )
{
    AD840x_CS_OFF;
	_delay_us( 2 );

	_set840xAdress( adress );
	_set840xVolume( volume );

	_delay_ms( 2 );
	AD840x_SDI_OFF;
	AD840x_CS_ON;
}

void setAD840xVolume( uint8_t volume )
{
	uint8_t i = 0;
	for ( i = 0; i < AD840x_NUMBERS; i++ )
	{
		set840xVolume( i, volume );
	}
}

void setAD840xMute( uint8_t on )
{
#ifndef AD8400
	if ( on )
	{
		AD840x_SHDN_OFF;
	}
	else
	{
		AD840x_SHDN_ON;
	}
#else
	if ( on )
	{
		set840xVolume( 0, 0 );
	}
	else
	{
		set840xVolume( 0, currentVolume );
	}
#endif
}

#ifdef AD8404
void setAD840xVolumeSet1( uint8_t volume )
{
	uint8_t i = 0;
	for ( i = 0; i < 2; i++ )
	{
		set840xVolume( i, volume );
	}
}

void setAD840xVolumeSet2( uint8_t volume )
{
	uint8_t i = 0;
	for ( i = 2; i < 4; i++ )
	{
		set840xVolume( i, volume );
	}
}
#endif
